local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/Danubius.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_dd.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/iron_density.png", "IRON_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_DeltaDanubius_2019",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -3,
	MaxHeight = 60,
	VillagePathList = {
		{
			Entrance = { 1020, 0, 411 },
			Exit = { 1020, 0, 411 }
		},
		{
			Entrance = { 1022, 0, 30 },
			Exit = { 1022, 0, 30 }
		},
		{
			Entrance = { 900, 0, 1020 },
			Exit = { 900, 0, 1020 }
		},
		{
			Entrance = { 640, 0, 1020 },
			Exit = { 640, 0, 1020 }
		},
		{
			Entrance = { 2, 0, 900 },
			Exit = { 2, 0, 900 }
		},
		{
			Entrance = { 4, 0, 985 },
			Exit = { 1021, 0, 135 }
		}
	},
	SpawnList = {
		},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.85,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.8,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create iron deposits
			DensityMap = "IRON_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_IRON" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})